%% PRINT_RTF : Printing matrices in RTF style
%
% ARGUMENTS   : X      -> Raw matrix.
%               Output -> listbox where the function will print the matrix.
%               header -> Header for each column.
%               labels -> Optional input, if it's present, the function will print
%                         the selected labels as labels for each row.
%

function Print_RTF(X,Output,header,labels)

[f1,f2]=size(X);
width=10000/(f2+1);

int='\intbl ';
cell='\cell ';
row='\row';
par='\par';
pard='\pard';

MyPrint(Output,'\qc');

%Capçalera
buff='\trowd\trgaph72';
buff2=[];
buff_labels2=[];
buff4='\clbrdrt\brdrs\clbrdrl\brdrs\clbrdrb\brdrs\clbrdrr\brdrs\cellx';
for i=1:f2+1
    buff3=sprintf('%.0f',width*i);
    buff2=[buff2 buff4 buff3];
    buff_labels=sprintf('%s %s',header{i},cell);
    buff_labels2=[buff_labels2 buff_labels];
end;
header=[int buff_labels2 row];

interline_cap=[buff buff2];

MyPrint(Output,interline_cap);
MyPrint(Output,header);

%Cos
buff2=[];
buff3=[];
buff4='\clbrdrl\brdrs\clbrdrr\brdrs\cellx';
for i=1:f2+1
    buff3=sprintf('%.0f',width*i);
    buff2=[buff2 buff4 buff3];
end;
interline_cos=[buff buff2];

%bottom

buff2=[];
buff4='\clbrdrl\brdrs\clbrdrb\brdrs\clbrdrr\brdrs\cellx';
for i=1:f2+1
    buff3=sprintf('%.0f',width*i);
    buff2=[buff2 buff4 buff3];
end;
interline_bottom=[buff buff2];

MyPrint(Output,interline_cos);
for i=1:f1
    
    if nargin==4
        buff0=sprintf('%s %s',labels{i},cell);
    else
        buff0=sprintf('%.0f %s',i,cell);
    end;
    
    buff2=[];
    for j=1:f2
        buff=sprintf('%5.2f %s',X(i,j),cell);
        buff2=[buff2 buff];
    end;
    
    MyPrint(Output,[int buff0 buff2 row]);
    
    if i==f1
        buff8='';
        for j=1:f2+1
            buff7='\cell ';
            buff8=[buff8 buff7];
        end;
        MyPrint(Output,interline_bottom);
        MyPrint(Output,[int buff8 row pard par]);
    else
        
    end;
end;












