%% ESPEMUL : Expected score and conditional variance of one subject in one item 
% according to the Modified graded response model (MGRM) 
%
% Uses factorial parametrization 

function [esp, varcon] = espemul (th,lam,thres,sige)


[h,tmp]=size(thres);
pi = zeros(h+1,1);
pi(1) = 1-(pconmul(th',lam,thres(1),sige));
for i=2:h,
    pi(i) = pconmul(th',lam,thres(i-1),sige) - pconmul(th',lam,thres(i),sige);
end;
pi(h+1)= 1 - sum(pi);

esp = 0;
sumcuad = 0;
for i=1:(h+1),
    esp = esp + i*pi(i);
    sumcuad = sumcuad + i*i*pi(i);
end;
varcon=sumcuad-(esp.*esp);

return;
