%% NEIGHBORS : Determine the neihgbors of an individual's score and his posiition
%
% ARGUMENTS   : xi  -> vector that search for the nearest neighbors
%               wi  -> map of xi missings
%               X   -> neighborhood
%               W   -> missings map
%               k   -> number of neighbors to return
%
% RETURN VALUE: Y   -> neighbors
%               pos -> position that take the neihbors in X
%

function [Y,pos] = neighbors(xi,wi,X,W,k)

[N,m]=size(X);

%selecciona els veins sense missings
ind=[];X_cc=[];
sw=sum(W')';
for i=1:N,
    if sw(i) == 0,
       ind = [ind; i];
       X_cc = [X_cc; X(i,:)];
    end;       
end;

%Treu missing segons el vector
xi_c = [];X_c=[];
 for j=1:m,
    if wi(j) == 0,
       xi_c = [xi_c xi(j)];
       X_c = [X_c X_cc(:,j)];
   end;
end;

%%calcular les distancies amb els veins
[n,tmp]=size(X_c);
deu=[];
for i=1:n,
     eu = ((xi_c - X_c(i,:))*(xi_c - X_c(i,:))')^(1/2);
     deu = [deu; eu];
end;

[sdeu,j]=sort(deu);
Y=X(ind(j(1:k)),:);

pos=ind(j(1:k))+1;
