%% REWLSC : WLS regression person-fit analysis for a single individual according  to the FA model
% espet-> vector de respuestas esperadas para el sujeto en el test
% filat-> patrn de respuestas para el sujeto en el test
%

function [inte,slo,q,ncrit,mct,mcw,mcb] = rewlsc(filat,espet,sige)

[n,m]= size (sige);
secon=sige';
varcon=secon.*secon;

% Computes the alpha=0.01 critical value of F

fc = finv(0.99,2,n-2);


% Computes the WLS weights and transforms the original variables
%weight=ones(1,n)./secon;
weight=ones(1,n)./diag(secon)';
wfilat=weight.*filat;
wespe=weight.*espet;

% Obtains the regression estimates, predicted scores and, se
tmp3=mean(wfilat);
tmp4=mean(wespe);
tmp5=cov(wfilat,wespe,1);
tmp6=tmp5(1,2);
tmp7=tmp5(2,2);
slo=tmp6./tmp7;
inte=tmp3-(slo.*tmp4);
wpred=(inte*ones(1,n))+(slo*wespe);
vartot=var(wfilat',1);
varpred=slo.*slo.*var(wespe',1);
varerr=(n/(n-2))*(vartot-varpred);

% Computes if the fitted regression significantly departs from the
% model expected regression
T=[ones(n,1),wespe'];
vecdif=[-inte,(1-slo)];
q=vecdif*T'*T*vecdif';
ncrit=2*varerr*fc;

% Obtains the mean square decomposition
d1=(wfilat-wespe);
d2=(wfilat-wpred);
d3=(wpred-wespe);
mct=(1/n)*d1*d1';
mcw=(1/n)*d2*d2';
mcb=(1/n)*d3*d3';
return;

