%% rlc: Person Fit index for continous model
%
% ARGUMENTS   : X   -> Participants' scores on items
%               L   -> Matrix of loadings (based on covariances)
%               PH  -> Variance of error
%               th  -> Factor scores estimates
%

function [Lc]  = rlc (X,L,PH,th);

[n,m] = size(X);
mu=mean(X)';
[s,k] = size(L);
df= m-k;
Lc  = [];
for i=1:n,
    v1=X(i,:)';
    v2=th(i,:)';
    tmp1 =loglik(v1,mu,L,PH,v2);
    tmp2 = sqrt(2*tmp1)-sqrt((2*df)-1);
    
    %tmp1 : Lc raw
    %tmp2 : Lc standardized (the one to be reported)
    Lc  = [Lc; tmp1 tmp2];
    
end;
