%% TARROTORTH : Orthogonal semi-specified target rotation
%
% Browne, M.W. Orthogonal rotation to a partially  specified target.
% British Journal of Mathematical and Statistical Psychology,
% 25, 1972, pp. 115-120.
%
% ARGUMENTS   : A -> ORTHOGONAL PATTERN TO BE ROTATED
%               B -> TARGET (9:  Non specified values in the target)
%               conver -> Convergence index
%
% RETURN VALUE: P -> Rotated pattern
%

function P = tarrotorth( A, B, conv)

aa=[];
b=[];
t=[];
h=[];
ind=[];
indv=[];

keas=[]; 
tt=[];

maxiter = 10;

fnun=0.0;inter=0;critp=0.0;critb=0.0;crit=0.0;sbbi=0.0;sffi=0.0;sfbi=0.0;tmin=0.0;tmp=0.0;tmpb=0.0;delta=0.0;
colag=0.0;cosma=0.0;den=0.0;gam=0.0;
nat=0.0;nit=0.0;ama=0.0;tama=0.0;a3=0.0;a4=0.0;a5=0.0;anum=0.0;aden=0.0;anumb=0.0;adenb=0.0;cott=0.0;tant=0.0;
dem=0.0;tolne=0.0;simin=0.0;deld=0.0;tdeld=0.0;omtdd=0.0;gamg=0.0;temp=0.0;gp=0.0;gpp=0.0;gppp=0.0;delinc=0.0;
deline=0.0;gmin=0.0;g=0.0;
sffl1=0.0;sffl2=0.0;sffi1=0.0;sfbi1=0.0;sffi2=0.0;sfbl2=0.0;sffi12=0.0;sffl12=0.0;sfbi21=0.0;sfbl12=0.0;sfi1=0.0;
newiter=0;iend=0;ite=0;jte=0;kte=0;lte=0;la=0;lend=0; kdon = 0; iter = 0; ok=1; newit=0; nemit=0; kse=0;
m=0; r=0; ist=0; i=0; j=0; l=0; k=0; ia=0; j1=0; j2=0; again=1; jp1=0;

dm=zeros(21,1);
dmd=zeros(21,1);gm=zeros(21,1);

  [m,r]=size(A);
  
  aa = zeros(m,r);
  for i=1:m,
     for j=1:r,
          aa(i,j) = A(i,j);
     end;
  end;
      
  b = zeros(m,r);
  for i=1:m,
     for j=1:r,
       if (abs(B(i,j) > 1.0)),
              b(i,j) = 9.0;
	   else 
              b(i,j) = B(i,j);
       end;
      end;
  end;
  
  ind  = zeros(m,r);
  indv = -1.0 * ones(m,1);
  keas = zeros(m,1);
  t    = eye(r);
  tt   = eye(r);
  h    = sum(A.*A);

  nemit = 10;
%tolne = 0.0000001;
  tolne = conv;
  simin = .0002909;
  dem   = -1.0;

  for i=1:21,
        dm(i)  = dem;
        dmd(i) = dem*dem;
        gm(i)  = sqrt(abs(1.0-dmd(i)));
        dem   = dem + 0.1;
   end;

%    C *** CONSTRUCT IND,KEAS ***
      for j=1:r,
		  ist = 1;
		  for i=1:m,
		      if (b(i,j) ~= 9.0),
				  ind(ist,j)=i;
				  if (b(i,j) ~= 0),
                      keas(j) = 1.0;
                  end;
				  ist=ist+1;
              end;
		      indv(j) = ist-1;
%		      //if (ist < (r-1))   error ----> columna poco definida.
          end;
          fnun=0; 
          for j=1:r,
              fnun = fnun + indv(j)+ 1.0;
          end;
              
      end;
          

%%//                      		   C *** INITIATE FOR OUTER CYCLE ***
      critp = 0.0;
      for j=1:r,
		iend = indv(j);
		if (iend >0),
	      for ia=1:iend,
			i = ind(ia,j);
			critp = critp + ((aa(i,j) - b(i,j))*(aa(i,j) - b(i,j))) ;
          end;
        end;
      end;

  nit = 0; nat = 1; newiter = 1;again=1;
  while (again == 1),
  
    if (nat == 1),
%//                   *** CHECK ORDER FOR OPTIMALITY ***
%// ------------------------------ METHOD 1 ------------------------------
%//            INTERCHANGE COLUMNS OF T SO AS TO MINIMIZE THE TRACE
	inter = 0;
%// C *** GET T ***
	for j=1:r,
	     iend = indv(j);
	     sbbi = 0.0;
	     if (iend>0),
			 for ia=1:iend,
			     i = ind(ia,j);
			     sbbi = sbbi + (b(i,j)*b(i,j));
             end;
         end;
	     for l=1:r,
			sffi = 0.0; sfbi = 0.0;
			if (iend>0) ,
				for ia=1:iend,
					i = ind(ia,j);
					sffi = sffi + (aa(i,l)*aa(i,l));
					sfbi = sfbi + (aa(i,l)*b(i,j));
				end;
				t(j,l) = sbbi + sffi - (2.0*abs(sfbi));
            end;
         end;
     end;

	critb = 0.0;
	for j=1:r,
        critb = critb + t(j,j);
    end;
        
%// *** FIND THE SMALLEST VALUE IN MATRIX T
	ite = 1; jte = 1;
	for j=1:r,
	    tmin = t(1,1);
	    for l=1:r,
		  for k=1:r,
		    if (t(k,l) < tmin),
				tmin = t(k,l);
				ite  = k;
				jte  = l;
            end;
          end;
        end;
	    if (ite ~= jte),
			inter = inter + 1;
			for i=1:m,
				tmp = aa(i,ite);
				aa(i,ite) = aa(i,jte);
				aa(i,jte) = tmp;
            end;
			for i=1:r,
				tmp = t(i,ite);
				t(i,ite) = t(i,jte);
				t(i,jte) = tmp;
            end;

        end;
%//     *** SET ROW AND COLUMN ITE TO 1.0D20
	    for i=1:r,
			t(ite,i) = 1.0;
			t(i,ite) = 1.0;
        end;
    end;

%// ------------------------------ METHOD 2 ------------------------------
%//             MINIMIZE THE DIAGONAL FOR 2X2 SUBMATRICES OF T

	if (inter > 0),                                             %*********************************************************************
%//  C *** GET NEW T ***
	  for j=1:r,
	       iend = indv(j);
	       sbbi = 0;
	       if (iend>0), 
               for ia=1:iend,
				   i = ind(ia,j);
				   sbbi = sbbi + (b(i,j)*b(i,j));
               end;
           end;
	       for l=1:r,
				sffi = 0.0; sfbi = 0.0;
				if (iend>0),
					for ia=1:iend,
						i = ind(ia,j);
						sffi = sffi + (aa(i,l)*aa(i,l));
						sfbi = sfbi + (aa(i,l)*b(i,j));
                    end;
					t(j,l) = sbbi + sffi - (2.0*abs(sfbi));
                end;
            end;
        end;
   end;

%///    C *** OBTAIN THE DIFFERENCE BETWEEN THE SUM OF THE DIAGONAL ELEMENTS AND
%///    C     THE SUM OF THE OFF-DIAGONAL ELEMMENTS FOR SUBMATRICES OF T
	for j=1:(r*r),
	     tmp = 0; kte = 0; lte = 0;
	     for k=1:r,
			for l=1:k, 
              if (k~=l),
				tmpb = t(k,l) + t(l,k) - t(k,k) - t(l,l);
				if (tmp > tmpb),
					tmp = tmpb; kte = k; lte = l;
                end;
              end;
            end;
         end;

	     if (tmp < 0),
%//         C *** INTERCHANGE COLUMNS KTE AND LTE OF FM AND B ***
			inter = inter + 1;
			for i=1:m,
				tmp = aa(i,kte);
				aa(i,kte) = aa(i,lte);
				aa(i,lte) = tmp;
            end;
			for i=1:r,
				tmp = t(i,kte);
				t(i,kte) = t(i,lte);
				t(i,lte) = tmp;
            end;
	       	tmp = 1;
	     else,
             break;
         end;
    end;

	for j=1:r,
	     sfbi = 0;
	     iend = indv(j);
	     if (iend >0), 
			for ia=1:iend,
				i = ind(ia,j);
				sfbi = sfbi + (aa(i,j)*b(i,j));
            end;
%            C * REFLECT
			if (sfbi < 0),
				for i=1:m,
                    aa(i,j) = -1.0 * aa(i,j);
                end;
            end;
        end;
    end;

%/////  C *** CALCULATE DEVIATION CRITERION
		if (inter ~= 0),
%/////  C       OLD METHOD
			crit = 0;
			for i=1:r,
                crit = crit + t(i,i);
            end;

        end;
    end;   %%%%%% if (nat == 1)
    
    
%//******************     LINEA 560   ********************

     kdon = 0;
     colag = -1.0;
     cosma =  1.0;

     %for j1=1:r,%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     for j1=1:(r-1),%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		 jp1 = j1 + 1;
		 iend = indv(j1);
		 if (keas(j1)==0.0),
		     sfi1 = 0.0;
		     for i=1:m,
                 sfi1 = sfi1 + aa(i,j1);
             end;
		     if (sfi1 < 0.0),
				for i=1:m,
                    aa(i,j1) = -1.0 * aa(i,j1);
                end;
             end;
         end;

		 for j2=jp1:r,
		      lend = indv(j2);
		      sffl1  = 0.0; sffl2  = 0.0;  sffi1  = 0.0;  sfbi1  = 0.0;
		      sffi2  = 0.0; sfbl2  = 0.0;  sffi12 = 0.0;  sffl12 = 0.0;
		      sfbi21 = 0.0; sfbl12 = 0.0;
		      if (iend > 0),
				 for ia = 1:iend,
				       i = ind(ia,j1);
				       sffi1  = sffi1 + aa(i,j1)*aa(i,j1);
				       sfbi1  = sfbi1 + aa(i,j1)*b(i,j1);
				       sffi2  = sffi2 + aa(i,j2)*aa(i,j2);
				       sffi12 = sffi12 + aa(i,j1)*aa(i,j2);
				       sfbi21 = sfbi21 + aa(i,j2)*b(i,j1);
                 end;
			     if (sfbi1<0),
			         for i=1:m, 
                       aa(i,j1) = -1.0 * aa(i,j1);
                     end;
			         sfbi1  = -1.0 * sfbi1;
			         sffi12 = -1.0 * sffi12;
                 end;
              end;
	
		      if (lend > 0),
                     for la=1:lend,
                        l = ind(la,j2);
					    sffl1  = sffl1  + aa(l,j1)*aa(l,j1);
					    sffl2  = sffl2  + aa(l,j2)*aa(l,j2);
					    sffl12 = sffl12 + aa(l,j1)*aa(l,j2);
					    sfbl2  = sfbl2  + aa(l,j2)*b(l,j2);
					    sfbl12 = sfbl12 + aa(l,j1)*b(l,j2);
                    end;
              end;
	
		      ama = (sffl1-sffi1) + (sffi2-sffl2);
		      if (sfbl2<0),
				  for l=1:m,
                      aa(l,j2) = -1.0 * aa(l,j2);
                  end;
				  sfbl2  = -1.0 * sfbl2; sffi12 = -1.0 * sffi12;
				  sffl12 = -1.0 *sffl12; sfbi21 = -1.0 * sfbi21;
              end;
		      tama  =  2.0 * ama;
		      a3    =  2.0 * (sffi12 - sffl12);
		      a4    = -2.0 * (sfbi1  + sfbl2 );
		      a5    =  2.0 * (sfbl12 - sfbi21);
		      anum  = abs(a3);
		      aden  = abs(ama);
		      anumb = abs(a5);
		      adenb = a4 * -1.0;
		      delta   = 0.0;
	
		      if (max(abs(anum),abs(aden)) == 0),
					  if (anumb>adenb),                        %***************************************                       
					      cott = adenb/anumb;
					      delta  = 1.0 /sqrt(1.0 + (cott*cott));
					      gam  = cott * delta;
					      if (a5>0),
                              delta = -1.0 * delta;
                          end;
					  elseif (adenb ~= 0),
					      tant = a5/a4;
					      gam  = 1.0/sqrt(1.0 + (tant*tant));
					      delta  = tant * gam;
                         
                      end;
		      else,
			    if ( max(abs(anumb),abs(adenb)) == 0),
                     if (anum<=aden),
		                  tant = anum/aden;
		                  gam  = 1.0/sqrt(1.0 + (tant*tant));
		                  delta  = tant*gam;
                     else,
		                  cott = aden/anum;
		                  delta  = 1.0/sqrt(1.0 + (cott*cott));
		                  gam = cott*delta;
                     end;
		             if (a3>0),
                         delta = delta*-1.0;
                     end;
		             if (ama<0),
                         gam = gam*-1.0;
                     end;
                     gam = sqrt((1.0 +gam)/2);
                     delta = delta/(2.0*gam);
			    else,
	
					 if (newit<4),
					     kse = -1;
					 else,
					   kse = 0;
					   newit = 0;
					   ok = 1;
					   while (newit<=nemit),
					      if (ok==1),
			%//               C *** NEWTON ITERATION ***
							  deld = delta*delta;
							  tdeld = 2.0 * deld;
							  omtdd = 1.0 - tdeld;
							  gamg  = 1.0 - deld;
							  gam   = sqrt(gamg);
							  temp  = gam*gamg;
							  gp    = tama*delta + a5 + (a3*omtdd - a4*delta)/gam;
							  gpp   = tama + (a3*delta*(tdeld-3.0)-a4)/temp;
							  gppp  = -3.0*(a3+a4*delta)/(temp*gam);
                          end;
                          if (gpp>0),
                              den = gpp - ((gp*gppp)/(2.0*gpp));           %%%%%%%%%%%%%%%%%%%*************************************************
                              delinc = -1.0*gp*den;
                              delta = delta + delinc;
                              if (abs(delta)>1.0),
                                  ok =0;
                              else,
                                   newit = newit + 1;
                                   if (abs(deline)< tolne),
                                       newit = nemit+1;
                                   elseif (newit<=nemit),
                                       ok =1;
                                   end;
                              end;
                          else,
                              dem = -1.0;
                              gmin = 1.0;
                              for i=1:21,
                                   dem = dm(i);
                                   g = ama*dmd(i) + (a3*dem+a4)*gm(i) + a5*dem; %%%%%%%%%%%%%%%%%%%%%%%%%********************************************
                                   if (g<gmin),
                                       gmin = g;
                                       delta = dem;
                                   end;
                               end;
                          end;
                          if (abs(delta)>=.99999), 
                              newit = nemit+1;
                          else,
                              kse = 1;
                              newit = 0;
                              ok =1;
                          end;
                       end;%%%%%%%%%% while (newit<=nemit)
                       
                    end;%%% if (newit<4)
                end;%%%if ( max(abs(anumb),abs(adenb)) == 0)
              end;%%%if (max(abs(anum),abs(aden)) == 0)
              
	%         //linea 750 es decir: continua
		      gam = sqrt((1.0-delta*delta));
              colag = max(colag,gam);
              cosma = min(cosma,gam);
              for i=1:m,
                      temp = aa(i,j1)*gam + aa(i,j2)*delta;
                      aa(i,j2) = -1.0 * aa(i,j1) * delta + aa(i,j2)*gam;
                      aa(i,j1) = temp;
              end;
              if (abs(delta)>simin),
                  kdon = kdon + 1;
              end;
	
         end;%%%for j2=jp1:r
     end;%%%for j1=1:r
     
%///////////////linea 780
%///////                         C *** CALCULATE CRITERION . END OF CYCLE ***
      crit = 0.0;
      for j=1:r,
	   iend = indv(j);
	   if (iend >0),
	      for ia=1:iend,
		      i = ind(ia,j);
		      crit = crit + ((aa(i,j) - b(i,j))*(aa(i,j) - b(i,j)));
          end;
       end;
      end;

      if (crit>=critp),
	     nit = nit + 1;
	     again = 0;
      else,
	     critp = crit;
	     nit = nit + 1;
	     nat = nit - (nit/5.0)*5.0;
	     if (kdon==0),
             again = 0;
	     elseif (nit<= 2),
             nat = 1;
         end;
	     if (nit<= 2),
             nat = 1;
         end;
	     if (nit== maxiter),
             again = 0;
         end;
      end;

      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      %Desctivar segones voltes
      again=0;
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      
  end;  %////// ve de while (again);
      
%//*********************  LINEA  800  *********************

 P =  aa;

 frr=crit;
 
return
