%% URBMAJ : Majoritation of a vector
%
% ARGUMENTS   : F   ->  Column vector to be majorized
%
% RETURN VALUE: PHI ->  Solution
%

function [PHI] = urbmaj (F);


  [n,m] = size (F);

  PHI = F.*F;
  
  m = mean(PHI);
  s =sqrt(std(PHI)^2*(n-1)/n);
  c = m + s/4;
  
  for i=1:n,
      if PHI(i) < c,
         PHI(i)=0;
      end;
  end;

return;
